def gv
pipeline {

	agent any
	tools {
		maven 'maven-3.8.6'
	}
	
	parameters {
		//string(name: 'APP_VERSION', defaultValue: '2.0', description: 'version to deploy on prod')
		string(name: 'DOCKER_APP_NAME', defaultValue: 'java-maven-app', description: '')
		choice(name: 'DOCKER_REPO', choices: ['192.168.100.119:8083', 'hub.docker.com'], description: 'docker repo')
	}

	stages {
        stage("init") {
            steps {
				script {
                	gv = load "script.groovy"
				}
            }
        }

//        stage('increment version') {
//            steps {
//                script {
//                    echo 'incrementing app version...'
//                    sh 'mvn build-helper:parse-version versions:set \
//                        -DnewVersion=\\\${parsedVersion.majorVersion}.\\\${parsedVersion.minorVersion}.\\\${parsedVersion.nextIncrementalVersion} \
//                        versions:commit'
//                    def matcher = readFile('pom.xml') =~ '<version>(.+)</version>'
//                    def version = matcher[0][1]
//                    env.IMAGE_NAME = "$version-$BUILD_NUMBER"
//                }
//            }
//        }

		stage("increment version") {
			steps {
				script {
					gv.incrementVersion()
				}
			}
		}

		stage("build jar") {
			steps {
				script {
					gv.buildJar()
				}
			}
		}

		stage("build image") {
			steps {
				script {
                    gv.buildImage()
				}
			}
		}
	

		stage("deploy") {
			steps {
				script {
					gv.deployApp()
				}
			}
		}		

		stage("commit version update") {
			steps {
				script {
					gv.commitVersionUpdate()
				}
			}
		}	
		
	}
}	
